////////////////////////////////////////////////////////////////////////////////
// DIALOGS.CPP
////////////////////////////////////////////////////////////////////////////////
#include <windows.h>
#include <winuser.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <shlobj.h>
#include "model.hpp"
#include "dialogs.hpp"

#define MAX_KEY_LENGTH  		256
#define MAX_VALUE_NAME  		256
#define DEF_MAX_LOG_LENGTH      1024 * 1000


////////////////////////////////////////////////////////////////////////////////

HWND 	hDeskTop;
HWND 	hButton1;
HWND 	hGrpBox1;
HWND 	hLogBox;
HWND 	hTimer1;
HWND 	hLowCaption;
HDC  	hDC;
HFONT   hFont,hFontBackUp;

////////////////////////////////////////////////////////////////////////////////

BOOL IsFirstRun = TRUE;
RECT gDeskTopRect;

//Ϻ   Ʈ ..   -_-;
//HKEY_CLASSES_ROOT/AppID/NateOn.EXE
//HKEY_CLASSES_ROOT/AppID/NateOnMMS_AX.DLL
//HKEY_CLASSES_ROOT/NateMessengerApiActiveX.NateOnApiAtx
//HKEY_CLASSES_ROOT/NateMessengerApiActiveX.NateOnApiAtx.1
//HKEY_CLASSES_ROOT/NateOn.NateComEnumBuddy
//HKEY_CLASSES_ROOT/NateOn.NateComEnumBuddy.1
//HKEY_CLASSES_ROOT/NateOn.NateMessengerApi
//HKEY_CLASSES_ROOT/NateOn.NateMessengerApi.1
//HKEY_CLASSES_ROOT/NATEONDOWNLOADMANAGER.NateonDownloadManagerCtrl.1
//HKEY_CLASSES_ROOT/NateOnMMS_AX3.NateOnMMSAtx3
//HKEY_CLASSES_ROOT/NateOnMMS_AX3.NateOnMMSAtx3.1
//HKEY_CLASSES_ROOT/NateOnSens.NateOnSensNet
//HKEY_CLASSES_ROOT/NateOnSens.NateOnSensNet.1
//HKEY_LOCAL_MACHINE/SOFTWARE/SK Communications
//HKEY_LOCAL_MACHINE/software/Microsoft/Windows/CurrentVersion/Uninstall/{697E41EA-AEBE-4B5F-884E-87B5CD6C70AC}

//ȯ溯  ġ
//HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Session Manager\Environment
//HKEY_CURRENT_USER\Environment

//#define REAL_ACTION

////////////////////////////////////////////////////////////////////////////////

extern LRESULT CALLBACK TimerProc(HWND hWnd,UINT uMsg, UINT idEvent, DWORD dwTime);

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

// *****************************************************
// **** Add string to LOG. (visual)
void AddToLog(LPTSTR str)
{
	char    tmpStr[DEF_MAX_LOG_LENGTH] = {0};
	UINT_32 PDcount;

 	GetWindowText(hLogBox,tmpStr,DEF_MAX_LOG_LENGTH);
	lstrcat(tmpStr,str);
	SetWindowText(hLogBox,tmpStr);
	
	PDcount = SendMessage(hLogBox,EM_GETLINECOUNT,0,0);
	SendMessage(hLogBox,EM_LINESCROLL,(WPARAM)0,(LPARAM)PDcount);
	SendMessage(hLogBox,EM_SETMODIFY,(WPARAM)FALSE,0);

}

// *****************************************************
// **** Clears log .
void ClearLog(void)
{
	SetWindowText(hLogBox,"");
}


// *****************************************************
// **** Erases file path from source string.
PSTRING StripFilePath(PSTRING srcStr)
{
	static
	LSTRING64   szBuff = {0};
	UINT_16     lastSlashFound = 0;
	UINT_16     Len;
	UINT_16     count;

	Len = strlen(srcStr);
	count = Len;

	while(1)
	{
		if(count==0) break;
		
		if(srcStr[count] == 0x5c) // 0x05c = "\"
		{
			lastSlashFound = count;
			break;
		}
		count--;
	}
	
	for(count=0;count<(strlen(srcStr)-lastSlashFound);count++)
	{
		szBuff[count]=srcStr[lastSlashFound+1+count];
	}

	szBuff[count] = '\0';

	return szBuff;
}

void EnableDropShadow(HWND  hWnd, bool DoEnable)
{
    DWORD classLong = GetClassLong(hWnd, GCL_STYLE);
 
    if (DoEnable)
        classLong = classLong | CS_DROPSHADOW;
    else
        classLong = classLong & ~CS_DROPSHADOW;
 
    SetClassLong(hWnd, GCL_STYLE, classLong);
}

BOOL ReadRegVal(char *reg_path, char *key, char *val, int val_buf_size ) // regб
{
    HKEY phk=0;
    DWORD nEC = REG_BINARY;
    DWORD size = val_buf_size;

    memset(val,0,val_buf_size);

    if (RegOpenKey(HKEY_LOCAL_MACHINE,reg_path,&phk) == ERROR_SUCCESS)
    {
    	RegQueryValueEx(phk, key, NULL,&nEC, (LPBYTE)val, &size );
	    RegCloseKey(phk);
	    
	    return TRUE;
	}
    return FALSE;
}



BOOL WriteRegVal(char *reg_path, char *key, char *val)          //reg write
{
    HKEY phk=0;
    long nRet;

    if (RegCreateKey(HKEY_LOCAL_MACHINE, reg_path, &phk) == ERROR_SUCCESS)
    {
    	nRet = RegSetValueEx(phk, key, 0, REG_SZ, (LPBYTE)val, strlen(val));
	    RegCloseKey(phk);
	    return TRUE;
	}

    return FALSE;
}


BOOL DeleteRegKey(char *reg_path)
{
	long nRet;
	
	if (RegDeleteKey(HKEY_LOCAL_MACHINE, reg_path) == ERROR_SUCCESS)
		return TRUE;
	else
	    return FALSE;
}

void DeleteFilesOnPath(char *path)
{
     HANDLE hSrch;
     WIN32_FIND_DATA wfd;
     BOOL bResult=TRUE;
     char drive[_MAX_DRIVE];
     char dir[MAX_PATH];
     char newpath[MAX_PATH];
     char delpath[MAX_PATH];

     hSrch=FindFirstFile(path,&wfd);
     if (hSrch == INVALID_HANDLE_VALUE) {
          return;
     }

     _splitpath(path,drive,dir,NULL,NULL);

     while (bResult)
	 {
          if (wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
		  {
				Sleep(10);
          }
		  else
		  {
              sprintf(delpath,"%s%s%s",drive,dir,wfd.cFileName);
#ifdef REAL_ACTION
              DeleteFile(delpath);
#else
			  AddToLog(delpath);
			  AddToLog("->virtual del.\r\n");
#endif
			  Sleep(10);
          }
          bResult=FindNextFile(hSrch,&wfd);
     }
     FindClose(hSrch);
}

void DeleteNateOnMenu(char *path)
{
     HANDLE hSrch;
     WIN32_FIND_DATA wfd;
     BOOL bResult=TRUE;
     char drive[_MAX_DRIVE];
     char dir[MAX_PATH];
     char newpath[MAX_PATH];
     char delpath[MAX_PATH];

     hSrch=FindFirstFile(path,&wfd);
     if (hSrch == INVALID_HANDLE_VALUE) {
          return;
     }

     _splitpath(path,drive,dir,NULL,NULL);

     while (bResult)
	 {
          if (wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
		  {
              if (strcmp(wfd.cFileName,".") && strcmp(wfd.cFileName,".."))
			  {
					if (!strncmp(wfd.cFileName,"Ʈ",6))
					{
						sprintf(newpath,"%s%s%s\\*.*",drive,dir,wfd.cFileName);
						AddToLog(newpath);
						AddToLog("->..");
						DeleteFilesOnPath(newpath);
						AddToLog("OK.\r\n");

						sprintf(newpath,"%s%s%s",drive,dir,wfd.cFileName);
#ifdef REAL_ACTION
						RemoveDirectory(newpath);
#else
						AddToLog(newpath);
						AddToLog("->virtual del.\r\n");
#endif
						Sleep(10);
					}
              }
          }
          else
          {
				if (!strncmp(wfd.cFileName,"Ʈ",6))
				{
					sprintf(newpath,"%s%s%s\\*.*",drive,dir,wfd.cFileName);
					AddToLog(newpath);
					AddToLog("->..");
					DeleteFilesOnPath(newpath);
					AddToLog("OK.\r\n");

					sprintf(newpath,"%s%s%s",drive,dir,wfd.cFileName);
#ifdef REAL_ACTION
					DeleteFile(newpath);
#else
					AddToLog(newpath);
					AddToLog("->virtual del.\r\n");
#endif
					Sleep(10);
				}
		  }
          bResult=FindNextFile(hSrch,&wfd);
     }
     FindClose(hSrch);

}

void DeleteFileList(char *path)
{
     HANDLE hSrch;
     WIN32_FIND_DATA wfd;
     BOOL bResult=TRUE;
     char drive[_MAX_DRIVE];
     char dir[MAX_PATH];
     char newpath[MAX_PATH];
     char delpath[MAX_PATH];

     hSrch=FindFirstFile(path,&wfd);
     if (hSrch == INVALID_HANDLE_VALUE) {
          return;
     }

     _splitpath(path,drive,dir,NULL,NULL);

     while (bResult)
	 {
          if (wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
		  {
              if (strcmp(wfd.cFileName,".") && strcmp(wfd.cFileName,".."))
			  {
		           AddToLog(newpath);
		           AddToLog("\r\n");
                   sprintf(newpath,"%s%s%s\\*.*",drive,dir,wfd.cFileName);
                   DeleteFileList(newpath);
		           Sleep(10);
              }
          }
		  else
		  {
              sprintf(delpath,"%s%s%s",drive,dir,wfd.cFileName);
#ifdef REAL_ACTION
              DeleteFile(delpath);
#else
			  AddToLog(delpath);
			  AddToLog("->virtual del.\r\n");
#endif
          }
          bResult=FindNextFile(hSrch,&wfd);
     }
     FindClose(hSrch);

#ifdef REAL_ACTION
	path[strlen(path)-3] = 0;
	RemoveDirectory(path);
#else
	path[strlen(path)-3] = 0;
	AddToLog(path);
	AddToLog("->(path)Virtual Del.\r\n");
#endif
}

BOOL RegFindFromKey(HKEY hUserKey,PSTRING SubKey,PSTRING FindName,PSTRING FindValue,PSTRING FoundPath)
{
    HKEY hKey, hSubKey;
    LONG lRet;
    DWORD dwSubKeyNumber, dwCount, dwValueNumber, dwValueCount,
        dwSubKeySize = 80;
    DWORD dwNameSize = 80, dwValueSize = 80;
    FILETIME FileTime;
    int n=0;
    static char szSubKey[80], szName[80], szValue[80];
    static char szBuff[80], szPrint[256];

    lRet = RegOpenKeyEx(hUserKey, SubKey, 0, KEY_ALL_ACCESS, &hKey);
    if(lRet != ERROR_SUCCESS)
        return FALSE;

    lRet = RegQueryInfoKey(hKey, NULL, 0, 0, &dwSubKeyNumber, NULL, NULL,
        NULL, NULL, NULL, NULL, &FileTime);
    if(lRet != ERROR_SUCCESS)
    {
        RegCloseKey(hKey);
        return FALSE;
    }

    dwCount = 0;

    do
    {
        RegEnumKeyEx(hKey, dwCount, szSubKey, &dwSubKeySize, NULL, NULL, 0, &FileTime);
        dwSubKeySize = 80;
        strcpy(szBuff, SubKey);
		if (szBuff[strlen(szBuff)] != '\\')
		{
			strcat(szBuff,"\\");
		}
        strcat(szBuff, szSubKey);
        lRet = RegOpenKeyEx(HKEY_LOCAL_MACHINE, szBuff, 0, KEY_ALL_ACCESS, &hSubKey);

        lRet = RegQueryInfoKey(hSubKey, NULL, 0, 0, NULL, NULL, NULL,
            &dwValueNumber, NULL, NULL, NULL, &FileTime);

        dwValueCount = 0;

        while(dwValueNumber > dwValueCount)
        {
            RegEnumValue(hSubKey, dwValueCount, szName, &dwNameSize, NULL,
                NULL, (unsigned char *)szValue, &dwValueSize);
            dwNameSize = dwValueSize = 80;

			if(!strcmp(szName,FindName))
			{
	            if (!strcmp(szValue,FindValue))
	            {
					strcpy(FoundPath,SubKey);
					if (FoundPath[strlen(FoundPath)] != '\\')
					{
						strcat(FoundPath,"\\");
					}
					strcat(FoundPath,szSubKey);
					return TRUE;
				}
			}

            n++;
            dwValueCount++;
        }
        RegCloseKey(hSubKey);
        dwCount++;
    } while(dwCount<dwSubKeyNumber);

    RegCloseKey(hKey);

    return FALSE;
}

BOOL SearchAndDestroy(void)
{
	LSTRING256  szBuf;
	LSTRING512  szLocation;
	HWND        FoundWin;
	
	LPITEMIDLIST Pidl;

	// PHASE 00 - Detect Program.
	AddToLog("\r\n-----------------------\r\n");
	AddToLog("α׷   ã ϴ ..");
	
	while(1)
	{
		FoundWin = FindWindow(NULL,"NateOn");
		if (FoundWin)
		{
			AddToLog("\r\nNateOn  ãҽϴ.");
			AddToLog("->  մϴ.\r\n");
			SendMessage(FoundWin, WM_CLOSE, 0, 0);
			SendMessage(FoundWin, WM_DESTROY, 0, 0);
			SendMessage(FoundWin, WM_NCDESTROY, 0, 0);
			SendMessage(FoundWin, WM_QUIT, 0, 0);
		}
		else break;
	}
	AddToLog("\r\n");


	// PHASE 01 - Delete Uninstall settings ...
	AddToLog("\r\n-----------------------\r\n");
	AddToLog("ġ  ã ϴ..");
	if (RegFindFromKey(HKEY_LOCAL_MACHINE,
	                   "software\\Microsoft\\Windows\\CurrentVersion\\Uninstall",
	                   "DisplayName",
	                   "Ʈ",
	                    szBuf))
	{
		AddToLog("ãҽϴ.\r\n");
		AddToLog("ġ  о ɴϴ...\r\n");
		ReadRegVal(szBuf,"InstallLocation",szLocation,512);
		AddToLog("ã Ű = ");
		AddToLog(szBuf);
		AddToLog("\r\n"); 
		AddToLog("ġ = ");
		AddToLog(szLocation);
		AddToLog("\r\n");
		AddToLog("Ű մϴ .. ");
#ifdef REAL_ACTION
		if (DeleteRegKey(szBuf))
		    AddToLog(".\r\n");
		else
		    AddToLog(".\r\n");
#else
			AddToLog("virtual del. \r\n");
#endif
	}
	else
	{
		AddToLog("ġ  ϴ.\r\n");
		strcpy(szLocation,"C:\\Program Files\\NATEON");
		AddToLog("Ʈ  ġ    մϴ.\r\n");
		AddToLog(szLocation);
		AddToLog("\r\n");		 
	}

	// PHASE 02 - Delete SK Communications
	AddToLog("\r\n-----------------------\r\n");
	AddToLog("Ʈ  Ʈ ..");
#ifdef REAL_ACTION
	if (DeleteRegKey("software\\SK Communications"))
	    AddToLog("Ϸ.\r\n");
	else
	    AddToLog(".\r\n");
#else
		AddToLog("Virtual del.\r\n");
#endif

	//PHASE 03 - Delete All Files !!!
	AddToLog("\r\n-----------------------\r\n");
	AddToLog("ġ ο ִ ϵ   մϴ..\r\n");
	if (strlen(szLocation))
	{
		strcat(szLocation,"\\*.*");
		AddToLog(szLocation);AddToLog("\r\n");
#ifdef REAL_ACTION
		DeleteFileList(szLocation);
#else
		AddToLog("Skipped for test.\r\n");
#endif
	}
	else
	{
		AddToLog("̹ Ǿϴ.\r\n");
	}

	//PHASE 04 - Delete Menus
	AddToLog("\r\n-----------------------\r\n");
	AddToLog(" ޴ ִ Ʈ  մϴ..\r\n");

	SHGetSpecialFolderLocation(0, CSIDL_COMMON_STARTMENU   , &Pidl);
	SHGetPathFromIDList(Pidl, szLocation);
	if (strlen(szLocation))
	{
		strcat(szLocation,"\\*.*");
		AddToLog(szLocation);AddToLog("\r\n");
		DeleteNateOnMenu(szLocation);
	}

	SHGetSpecialFolderLocation(0, CSIDL_COMMON_STARTUP  , &Pidl);
	SHGetPathFromIDList(Pidl, szLocation);
	if (strlen(szLocation))
	{
		strcat(szLocation,"\\*.*");
		AddToLog(szLocation);AddToLog("\r\n");
		DeleteNateOnMenu(szLocation);
	}

	SHGetSpecialFolderLocation(0, CSIDL_COMMON_PROGRAMS   , &Pidl);
	SHGetPathFromIDList(Pidl, szLocation);
	if (strlen(szLocation))
	{
		strcat(szLocation,"\\*.*");
		AddToLog(szLocation);AddToLog("\r\n");
		DeleteNateOnMenu(szLocation);
	}

	SHGetSpecialFolderLocation(0, CSIDL_COMMON_DESKTOPDIRECTORY   , &Pidl);
	SHGetPathFromIDList(Pidl, szLocation);
	if (strlen(szLocation))
	{
		strcat(szLocation,"\\*.*");
		AddToLog(szLocation);AddToLog("\r\n");
		DeleteNateOnMenu(szLocation);
	}

	SHGetSpecialFolderLocation(0, CSIDL_STARTMENU    , &Pidl);
	SHGetPathFromIDList(Pidl, szLocation);
	if (strlen(szLocation))
	{
		strcat(szLocation,"\\*.*");
		AddToLog(szLocation);AddToLog("\r\n");
		DeleteNateOnMenu(szLocation);
	}

	SHGetSpecialFolderLocation(0, CSIDL_STARTUP  , &Pidl);
	if (strlen(szLocation))
	{
		strcat(szLocation,"\\*.*");
		AddToLog(szLocation);AddToLog("\r\n");
		DeleteNateOnMenu(szLocation);
	}

	SHGetSpecialFolderLocation(0, CSIDL_PROGRAMS   , &Pidl);
	SHGetPathFromIDList(Pidl, szLocation);
	if (strlen(szLocation))
	{
		strcat(szLocation,"\\*.*");
		AddToLog(szLocation);AddToLog("\r\n");
		DeleteNateOnMenu(szLocation);
	}

	SHGetSpecialFolderLocation(0, CSIDL_DESKTOPDIRECTORY   , &Pidl);
	SHGetPathFromIDList(Pidl, szLocation);
	if (strlen(szLocation))
	{
		strcat(szLocation,"\\*.*");
		AddToLog(szLocation);AddToLog("\r\n");
		DeleteNateOnMenu(szLocation);
	}

	return TRUE;
} 

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////
// Calls when it before WM_CREATE messege arrived.
HWND CreateMainWindow(HWND *hWnd,WNDCLASSEX *wincl,HINSTANCE *hThisInstance,WNDPROC *CB)
{
	return NULL;
}

///////////////////////////////////////////////////
// Calls when it met WM_CREATE messege on winMain();
void JobOnCreate(HWND hWnd,UINT message, WPARAM wParam, LPARAM lParam)
{
	OSVERSIONINFO ver;
	INT32   sWidth,sHeight;
	INT32   setX,setY;
	FLOAT	OStype = 0.0f;

	sWidth  = GetSystemMetrics(SM_CXSCREEN);
	sHeight = GetSystemMetrics(SM_CYSCREEN);
	
	setX    = ( sWidth - DEF_WIN_WIDTH ) / 2;
	setY    = ( sHeight - DEF_WIN_HEIGHT ) / 2;

	SetWindowPos(hWnd,HWND_NOTOPMOST,setX,setY,DEF_WIN_WIDTH,DEF_WIN_HEIGHT,SWP_NOSIZE);

	hDC     = GetDC(hWnd);
	hFont 	=  CreateFont(12,0,0,0,0,0,0,0,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,FF_DONTCARE,"");

	hFontBackUp = (HFONT)SelectObject(hDC, hFont);
	SelectObject(hDC,hFont);

    SendMessage(hWnd,WM_SETFONT,(WPARAM)hFont,(LPARAM)TRUE);
    SendMessage(hGrpBox1,WM_SETFONT,(WPARAM)hFont,(LPARAM)TRUE);
    SendMessage(hButton1,WM_SETFONT,(WPARAM)hFont,(LPARAM)TRUE);
    SendMessage(hLowCaption,WM_SETFONT,(WPARAM)hFont,(LPARAM)TRUE);
    SendMessage(hLogBox,WM_SETFONT,(WPARAM)hFont,(LPARAM)TRUE);

	// Make shadows enables ...
	ver.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&ver);
	if (ver.dwMinorVersion >= 10)
		OStype = ver.dwMajorVersion + (ver.dwMinorVersion * 0.01);
	else
		OStype = ver.dwMajorVersion + (ver.dwMinorVersion * 0.1);

	//Operating system           Version number 
	//Windows Server "Longhorn"  6.0 
	//Windows Vista              6.0 
	//Windows Server 2003 R2     5.2 
	//Windows Server 2003        5.2 
	//Windows XP                 5.1 
	//Windows 2000               5.0 
	//Windows Me                 4.90 
	//Windows 98                 4.10 
	//Windows NT 4.0             4.0 
	//Windows 95                 4.0 
	
	if ((OStype > 5.0f)&&(OStype < 6.0f)) EnableDropShadow(hWnd,1);
}

///////////////////////////////////////////////////
// Creates components
void CreateComponents(HWND hWnd,UINT message, WPARAM wParam, LPARAM lParam)
{

	// GroupBox 1
	hGrpBox1    = CreateWindow("Button","ֻ~",
                                WS_CHILD | WS_VISIBLE | BS_GROUPBOX,
	                            0,0,394,50,hWnd ,(HMENU) JOB_NONE,
	                            ((LPCREATESTRUCT) lParam)->hInstance,NULL);
	// Load ADF button
	hButton1    = CreateWindow ("BUTTON","ãƼ ׿ָ",WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
								20, 20, 350, 20,hWnd,(HMENU) JOB_BUTTON01,
								((LPCREATESTRUCT) lParam)->hInstance,NULL);
	// Log
	hLogBox      = CreateWindow("Edit","",
	                            WS_CHILD | WS_VISIBLE | WS_BORDER  | WS_HSCROLL | WS_VSCROLL | ES_AUTOHSCROLL | ES_AUTOVSCROLL | ES_MULTILINE  | ES_READONLY,
	                            0,55,394,345,hWnd ,(HMENU) JOB_NONE,
	                            ((LPCREATESTRUCT) lParam)->hInstance,NULL);

	// Copyright
    hLowCaption  = CreateWindow("Static","(C)Copyright2007 KIM,Min Chul",
                                WS_CHILD | WS_VISIBLE | WS_DISABLED | SS_RIGHT,
	                            0,405,391,15,hWnd ,(HMENU) JOB_NONE,
	                            ((LPCREATESTRUCT) lParam)->hInstance,NULL);

}

///////////////////////////////////////////////////
// Timer callback
void JobOnTimer(HWND hWnd,UINT message, WPARAM wParam, LPARAM lParam)
{
	// Do Something ...

	return;
}

///////////////////////////////////////////////////
// On Activated callback
void JobOnActivate(HWND hWnd,UINT message, WPARAM wParam, LPARAM lParam)
{
	if (IsFirstRun)
	{
		IsFirstRun = FALSE;

		AddToLog("Ʈ   α׷ ver 20080101\r\n");
		AddToLog(" - 2007 ö(denkami@gmail.com) \r\n");
		AddToLog("\r\n");
		AddToLog("[˸]\r\n");
		AddToLog("-  α׷ Ʈ ġ ǰ  ȵǴ е   ϴ.\r\n");
		AddToLog("- Windows2000  (Vista )    մϴ.\r\n");
		AddToLog("-  α׷  Ʈ¿ ؼ å  ʽϴ.\r\n");
		AddToLog("-  Ʈ   ȮҶ Ÿ  ֽñ ٶϴ.\r\n");
		AddToLog("\r\n");
		AddToLog("α׷ غ Ǿϴ.\r\n");
		AddToLog("ãƼ ׿ָ ư ּ.\r\n");
		AddToLog("\r\n");
	}
}

///////////////////////////////////////////////////
// On Paint callback
void JobOnPaint(HWND hWnd,PAINTSTRUCT *ps)
{
	HDC 		hdc;
	
    hdc=BeginPaint(hWnd,ps);
    // Something draw ???
	//
    EndPaint(hWnd,ps);
}

///////////////////////////////////////////////////
// On Close callback
void JobOnClose(HWND hWnd,UINT message, WPARAM wParam, LPARAM lParam)
{
	AddToLog("α׷  մϴ.\r\n");
}

///////////////////////////////////////////////////
// On Command (by component) callback
void JobOnCommand(HWND hWnd,UINT message, WPARAM wParam, LPARAM lParam)
{
	static 		OPENFILENAME ofn = {0};
	LPTSTR  	szFileName[MAX_PATH] = {0};
	UINT_8      comIndex = 0;
	UINT_8      brIndex = 0;
    LSTRING32   comStr = {0};
    LSTRING256  tmpStr = {0};
    UINT_32     comBR = 0;
    LSTRING256  fname1;
    LSTRING256  fname2;

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// LOAD ADF/JAR FILE BUTTON CLICKED.
	if (LOWORD(wParam) == JOB_BUTTON01 && HIWORD(wParam) == BN_CLICKED)
	{
		EnableWindow(hButton1,FALSE);
		AddToLog(" Ʈ ˻մϴ...\r\n");		
		
		if (SearchAndDestroy())
		{
			AddToLog("\r\n --------------------------- \r\n");
			AddToLog("Ϸ Ǿϴ.\r\n");
		}
		else
		{
			AddToLog("\r\n --------------------------- \r\n");
			AddToLog(" Ʈ ϴ.\r\n");
		}
		 
		EnableWindow(hButton1,TRUE);
    }
	return;
}

///////////////////////////////////////////////////
// Key Down/Up Event callback
void JobOnKeyProc(HWND hWnd,int KeyState,int Key)
{
	// DOn't care HWND .
	
	if (KeyState == DEF_KEY_DOWN)
	{
		switch(Key)
		{
			case VK_F5  : ClearLog(); break;
		}
	}
	return;
}

///////////////////////////////////////////////////
// On Destroy callback
void JobOnDestroy(HWND hWnd,UINT message, WPARAM wParam, LPARAM lParam)
{
	// Free all handles...
	DestroyWindow(hGrpBox1);
	DestroyWindow(hButton1);
	DestroyWindow(hLogBox);
	DestroyWindow(hLowCaption);	

	SelectObject(hDC, hFontBackUp);
	DeleteObject(hFont);
}
