////////////////////////////////////////////////////////////////////////////////
// MAIN.CPP
// ===========================================================================
// (C)2007 Veloxsoft - KIM , Min Chul. (mckim@veloxsoft.com)
////////////////////////////////////////////////////////////////////////////////

#include <windows.h>
#include "main.hpp"
#include "dialogs.hpp"

PAINTSTRUCT ps;

LRESULT CALLBACK TimerProc(HWND hWnd,UINT uMsg, UINT idEvent, DWORD dwTime)
{
    JobOnTimer(hWnd,uMsg,0,0);
}

LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)                  /* handle the messages */
    {
		case WM_CREATE:
            CreateComponents(hwnd,message,wParam,lParam);
            JobOnCreate(hwnd,message,wParam,lParam);
			break;
			
		case WM_ACTIVATE:
            JobOnActivate(hwnd,message,wParam,lParam);
			break;
			
		case WM_CLOSE:
            PostQuitMessage (0);       /* send a WM_QUIT to the message queue */
			break;
			
		case WM_KEYDOWN:
            JobOnKeyProc(hwnd,DEF_KEY_DOWN,wParam);
			break;
			
		case WM_KEYUP:
            JobOnKeyProc(hwnd,DEF_KEY_UP,wParam);
			break;
			
		case WM_PAINT:
            JobOnPaint(hwnd,&ps);
            break;

		case WM_TIMER:
			JobOnTimer(hwnd,message,wParam,lParam);
			break;
			
        case WM_DESTROY:
            JobOnDestroy(hwnd,message,wParam,lParam);
            break;

		case WM_COMMAND:
			JobOnCommand(hwnd,message,wParam,lParam);
			break;

        default:                      /* for messages that we don't deal with */
            return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return 0;
}


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

extern HICON A;

int WINAPI WinMain (HINSTANCE hThisInstance,
					HINSTANCE hPrevInstance,
					LPSTR lpszArgument,
					int nFunsterStil)
{
    HWND 		hwnd;
    MSG 		messages;
    WNDCLASSEX 	wincl;
    BOOL 		bQuit			= FALSE;
    MSG 		msg;
    
    wincl.hInstance = (HINSTANCE)hThisInstance;
    wincl.lpszClassName = DEF_WIN_CLASS_NAME;
    wincl.lpfnWndProc = WindowProcedure;
    wincl.style = CS_DBLCLKS;
    wincl.cbSize = sizeof (WNDCLASSEX);

    wincl.hIcon = LoadIcon (NULL, "A");
    wincl.hIconSm = LoadIcon (NULL, "A");
    wincl.hIconSm = wincl.hIcon;
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;
    wincl.cbClsExtra = 0;
    wincl.cbWndExtra = 0;
    wincl.hbrBackground = (HBRUSH) COLOR_WINDOW;

    if (!RegisterClassEx (&wincl)) return 0;

    hwnd = CreateWindowEx (
           WS_EX_ACCEPTFILES,
           DEF_WIN_CLASS_NAME,
           DEF_WIN_TITLE_NAME,
           DEF_WIN_TYPE,
           CW_USEDEFAULT,
           CW_USEDEFAULT,
           DEF_WIN_WIDTH,
           DEF_WIN_HEIGHT,
           HWND_DESKTOP,
           NULL,
           hThisInstance,
           NULL
           );
    
    if (hwnd)
    {
    	ShowWindow(hwnd, nFunsterStil);
	} else {
		MessageBox(hwnd,"ERROR","Error while create Window.",MB_OK | MB_ICONWARNING);
		return 0;
	}

	// =====================================================================
	// == LOOP !!!
	// =====================================================================
    while (!bQuit)
    {
        /* check for messages */
        if (PeekMessage (&msg, NULL, 0, 0, PM_REMOVE))
        {
            /* handle or dispatch messages */
            if (msg.message == WM_QUIT)
            {
                bQuit = TRUE;
            }
            else
            {
                TranslateMessage (&msg);
                DispatchMessage (&msg);
            }
        }
        else
        {
			// Something do ?
            Sleep (1);
        }
    }

	// =====================================================================
	// =====================================================================

    return messages.wParam;
}
