////////////////////////////////////////////////////////////////////////////////
// MODEL.HPP
////////////////////////////////////////////////////////////////////////////////

#define DEF_MODEL_DOS       0x0000
#define DEF_MODEL_WIN16     0x0001
#define DEF_MODEL_WIN32     0x0002
#define DEF_MODEL_WIN64     0x0004

#define DEF_MODEL_UNIX      0x0010
#define DEF_MODEL_LINUX     0x0020

#define DEF_MODEL_X86       0x0100
#define DEF_MODEL_ALPHA     0x0200
#define DEF_MODEL_ARM       0x0400

#define DEF_MODEL_GL10      0x0001
#define DEF_MODEL_GL11      0x0002
#define DEF_MODEL_GL12      0x0004
#define DEF_MODEL_GL15      0x0008
#define DEF_MODEL_GL18      0x0010
#define DEF_MODEL_GL20      0x0020

#define DEF_MODEL_GLES      0x0100
#define DEF_MODEL_GLUT      0x0200

#define DEF_SHADER_NONE     0
#define DEF_SHADER_LVL1     1
#define DEF_SHADER_LVL2     2

#define DEF_KEY_DOWN        1
#define DEF_KEY_UP          2

// KEY defines small game/PDA/PMP machines
#define DEF_MKEY_UP         0x00000001
#define DEF_MKEY_LEFT       0x00000002
#define DEF_MKEY_RIGHT      0x00000004
#define DEF_MKEY_DOWN       0x00000008
#define DEF_MKEY_A		    0x00000010
#define DEF_MKEY_B	        0x00000020
#define DEF_MKEY_C		    0x00000040
#define DEF_MKEY_D		    0x00000080
#define DEF_MKEY_E          0x00000100
#define DEF_MKEY_F          0x00000200
#define DEF_MKEY_G          0x00000400
#define DEF_MKEY_H          0x00000800
#define DEF_MKEY_I          0x00001000
#define DEF_MKEY_J          0x00002000
#define DEF_MKEY_K          0x00004000
#define DEF_MKEY_L          0x00008000

typedef float               FLOAT;
typedef double              DFLOAT;
typedef unsigned long       UINT_32;
typedef unsigned short      UINT_16;
typedef unsigned char       UINT_8;
typedef signed long         INT_32;
typedef signed short        INT_16;
typedef signed char         INT_8;
typedef unsigned char       BOOLEAN;
typedef char*               PSTRING;
typedef char		        LSTRING512[512];
typedef char		        LSTRING256[256];
typedef char		        LSTRING128[128];
typedef char		        LSTRING64[64];
typedef char		        LSTRING32[32];



